<template>
  <div class="sw-gs-error">
    <div class="sw-gs-error-header-wrapper">
      <SfHeading class="sw-gs-error-message"
                 :level="1"
                 :title="notAuthorizedError? $t('No access') : `${code}`"
                 :description="(error.statusCode === 500 && joinAsGuideError) ? error.messages[0].detail : $t(message)"/>
    </div>

    <div v-if="joinAsGuideError">
      <SwButton v-if="error && notAuthorizedError"
                class="sw-gs-error-logout-btn is-guide"
                title="$t('Logout')"
                @click="triggerLogout('guide')">
        {{ $t('Logout') }}
      </SwButton>
    </div>
    <div v-else>
      <SwButton v-if="error && (notAuthorizedError)"
                class="sw-gs-error-logout-btn is-client"
                title="$t('Logout')"
                @click="triggerLogout('client')">
        {{ $t('Logout') }}
      </SwButton>
    </div>
  </div>
</template>

<script>
  import { SfHeading } from "@storefront-ui/vue";
  import SwButton from "@/components/atoms/SwButton.vue";
  import { useUser } from "@shopware-pwa/composables";
  import { useAdminApiInstance } from "../logic/composables/useAdminApiInstance";
  import { useAppointment } from "../logic/composables/useAppointment";

  const customMessageDictionary = {
    401: "You do not have access to this appointment, but you can try to log in again with a different user.",
    403: "You do not have access to this appointment, but you can try to log in again with a different user.",
    404: "We can't find the presentation you are looking for.",
    500: "Error - Something went wrong"
  }

  const getMessageForCode = (code) => customMessageDictionary[code]

  export default {
    name: "SwGsError",
    components: {
      SfHeading,
      SwButton
    },
    props: {
      error: {
        type: Object,
        default: () => {},
      },
      joinAsGuideError: {
        type: Boolean,
        default: false,
      },
    },
    setup() {
      const { logout } = useUser();
      const { unsetAuthentication: logoutAsGuide } = useAdminApiInstance();
      const { resetAppointmentValues } = useAppointment();
      async function triggerLogout(type) {
        if (type === 'guide') {
          await logoutAsGuide(true);
        }
        if (type === 'client') {
          await logout();
        }

        resetAppointmentValues();
      }

      return {
        triggerLogout,
      }
    },
    computed: {
      notAuthorizedError() {
        return this.error &&  (this.error.statusCode === 403 || this.error.statusCode === 401);
      },
      code() {
        return this.error && this.error.status ? this.error.status : this.error && this.error.statusCode ? this.error.statusCode : 500
      },
      message() {
        return getMessageForCode(this.code) || this.error?.detail
      },
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-error {
    margin: var(--spacer-xl) 0;
  }

  .sw-gs-error-header-wrapper {
    display: flex;
    justify-content: center;
    padding: var(--spacer-xl);
  }

  .sw-gs-error-message {
    --heading-title-margin: var(--spacer-sm) 0;
    --heading-title-color: var(--c-primary);
    --heading-description-color: var(--c-secondary-variant);
    --heading-description-font-size: var(--font-size--base);
    --heading-description-margin: 0 var(--spacer-base);
    --heading-description-font-family: var(--font-family--primary);
    --heading-title-font-weight: var(--font-weight--semibold);
    @include for-desktop {
      --heading-title-font-size: 5rem;
    }
  }

  .sw-gs-error-logout-btn {
    margin: 0 auto;
  }
</style>
